import type { CallContext, CallOptions } from "nice-grpc-common";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "";
export interface Event {
    /** the tenant id */
    tenantId: string;
    /** the id of the event */
    eventId: string;
    /** the key for the event */
    key: string;
    /** the payload for the event */
    payload: string;
    /** when the event was generated */
    eventTimestamp: Date | undefined;
}
export interface PutLogRequest {
    /** the step run id for the request */
    stepRunId: string;
    /** when the log line was created */
    createdAt: Date | undefined;
    /** the log line message */
    message: string;
    /** the log line level */
    level?: string | undefined;
    /** associated log line metadata */
    metadata: string;
}
export interface PutLogResponse {
}
export interface PushEventRequest {
    /** the key for the event */
    key: string;
    /** the payload for the event */
    payload: string;
    /** when the event was generated */
    eventTimestamp: Date | undefined;
}
export interface ReplayEventRequest {
    /** the event id to replay */
    eventId: string;
}
export declare const Event: {
    encode(message: Event, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): Event;
    fromJSON(object: any): Event;
    toJSON(message: Event): unknown;
    create(base?: DeepPartial<Event>): Event;
    fromPartial(object: DeepPartial<Event>): Event;
};
export declare const PutLogRequest: {
    encode(message: PutLogRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PutLogRequest;
    fromJSON(object: any): PutLogRequest;
    toJSON(message: PutLogRequest): unknown;
    create(base?: DeepPartial<PutLogRequest>): PutLogRequest;
    fromPartial(object: DeepPartial<PutLogRequest>): PutLogRequest;
};
export declare const PutLogResponse: {
    encode(_: PutLogResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PutLogResponse;
    fromJSON(_: any): PutLogResponse;
    toJSON(_: PutLogResponse): unknown;
    create(base?: DeepPartial<PutLogResponse>): PutLogResponse;
    fromPartial(_: DeepPartial<PutLogResponse>): PutLogResponse;
};
export declare const PushEventRequest: {
    encode(message: PushEventRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PushEventRequest;
    fromJSON(object: any): PushEventRequest;
    toJSON(message: PushEventRequest): unknown;
    create(base?: DeepPartial<PushEventRequest>): PushEventRequest;
    fromPartial(object: DeepPartial<PushEventRequest>): PushEventRequest;
};
export declare const ReplayEventRequest: {
    encode(message: ReplayEventRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ReplayEventRequest;
    fromJSON(object: any): ReplayEventRequest;
    toJSON(message: ReplayEventRequest): unknown;
    create(base?: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
    fromPartial(object: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
};
export type EventsServiceDefinition = typeof EventsServiceDefinition;
export declare const EventsServiceDefinition: {
    readonly name: "EventsService";
    readonly fullName: "EventsService";
    readonly methods: {
        readonly push: {
            readonly name: "Push";
            readonly requestType: {
                encode(message: PushEventRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): PushEventRequest;
                fromJSON(object: any): PushEventRequest;
                toJSON(message: PushEventRequest): unknown;
                create(base?: DeepPartial<PushEventRequest>): PushEventRequest;
                fromPartial(object: DeepPartial<PushEventRequest>): PushEventRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                encode(message: Event, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Event;
                fromJSON(object: any): Event;
                toJSON(message: Event): unknown;
                create(base?: DeepPartial<Event>): Event;
                fromPartial(object: DeepPartial<Event>): Event;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly replaySingleEvent: {
            readonly name: "ReplaySingleEvent";
            readonly requestType: {
                encode(message: ReplayEventRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): ReplayEventRequest;
                fromJSON(object: any): ReplayEventRequest;
                toJSON(message: ReplayEventRequest): unknown;
                create(base?: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
                fromPartial(object: DeepPartial<ReplayEventRequest>): ReplayEventRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                encode(message: Event, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): Event;
                fromJSON(object: any): Event;
                toJSON(message: Event): unknown;
                create(base?: DeepPartial<Event>): Event;
                fromPartial(object: DeepPartial<Event>): Event;
            };
            readonly responseStream: false;
            readonly options: {};
        };
        readonly putLog: {
            readonly name: "PutLog";
            readonly requestType: {
                encode(message: PutLogRequest, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): PutLogRequest;
                fromJSON(object: any): PutLogRequest;
                toJSON(message: PutLogRequest): unknown;
                create(base?: DeepPartial<PutLogRequest>): PutLogRequest;
                fromPartial(object: DeepPartial<PutLogRequest>): PutLogRequest;
            };
            readonly requestStream: false;
            readonly responseType: {
                encode(_: PutLogResponse, writer?: _m0.Writer): _m0.Writer;
                decode(input: _m0.Reader | Uint8Array, length?: number): PutLogResponse;
                fromJSON(_: any): PutLogResponse;
                toJSON(_: PutLogResponse): unknown;
                create(base?: DeepPartial<PutLogResponse>): PutLogResponse;
                fromPartial(_: DeepPartial<PutLogResponse>): PutLogResponse;
            };
            readonly responseStream: false;
            readonly options: {};
        };
    };
};
export interface EventsServiceImplementation<CallContextExt = {}> {
    push(request: PushEventRequest, context: CallContext & CallContextExt): Promise<DeepPartial<Event>>;
    replaySingleEvent(request: ReplayEventRequest, context: CallContext & CallContextExt): Promise<DeepPartial<Event>>;
    putLog(request: PutLogRequest, context: CallContext & CallContextExt): Promise<DeepPartial<PutLogResponse>>;
}
export interface EventsServiceClient<CallOptionsExt = {}> {
    push(request: DeepPartial<PushEventRequest>, options?: CallOptions & CallOptionsExt): Promise<Event>;
    replaySingleEvent(request: DeepPartial<ReplayEventRequest>, options?: CallOptions & CallOptionsExt): Promise<Event>;
    putLog(request: DeepPartial<PutLogRequest>, options?: CallOptions & CallOptionsExt): Promise<PutLogResponse>;
}
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
